package com.switchyard.tests;

import org.junit.Assert;

import static org.switchyard.component.bpm.BPMConstants.CORRELATION_KEY_PROPERTY;
import static org.switchyard.component.bpm.BPMConstants.PROCESSS_INSTANCE_ID_PROPERTY;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;
import org.switchyard.test.SwitchYardTestKit;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(config = SwitchYardTestCaseConfig.SWITCHYARD_XML, mixins = { CDIMixIn.class })
public class ServiceProcessTest {

	private SwitchYardTestKit testKit;
	private CDIMixIn cdiMixIn;
	@ServiceOperation("ServiceProcess")
	private Invoker service;

	@Test
	public void testSubmit() throws Exception {
		// TODO Auto-generated method stub
		// initialize your test message
		Payload message = new Payload();
		message.setId(2333l);
		message.setValue("Unit test value");
		Payload result = service.operation("submit").sendInOut(message)
				.getContent(Payload.class);

		System.out.println("result: " + result);

		Payload message2 = new Payload();
		message2.setId(2444l);
		message2.setValue("Unit Signal test value");
		result = service.operation("signalTest1")
				.property(PROCESSS_INSTANCE_ID_PROPERTY, "1")
				.sendInOut(message2).getContent(Payload.class);

		// result = service.operation("signalTest1").sendInOut(message)
		// .getContent(Payload.class);

		System.out.println("result: " + result);

		// validate the results
		Assert.assertTrue("Implement me", true);
	}

	// @Test
	// public void testSignalTest1() throws Exception {
	// // TODO Auto-generated method stub
	// // initialize your test message
	// Payload message = new Payload();
	// message.setId(2333l);
	// message.setValue("Unit test signal value");
	// Payload result = service.operation("signalTest1").sendInOut(message)
	// .getContent(Payload.class);
	//
	// System.out.println("result: " + result);
	//
	// // validate the results
	// Assert.assertTrue("Implement me", true);
	// }

}
